IBurpExtender
Keywords: IBurpExtender interface

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## Interface IBurpExtender

All Known Implementing Classes:
  BurpExtender

    public interface IBurpExtender

This interface allows third-party code to extend burp suite's functionality. Implementations must be called BurpExtender, must be declared public, and must provide a default (public, no-argument) constructor. On startup, burp searches its classpath for a class called BurpExtender, and attempts to dynamically load and instantiate this class. The IBurpExtender methods implemented will then be dynamically invoked as appropriate.

Partial implementations are acceptable. The class will be used provided at least one of the interface's methods is implemented. A single instance of BurpExtender will be instantiated and shared between all plugins.

To make use of the interface, create a class called BurpExtender which implements one or more methods of the interface, and place this into the application's classpath at startup. For example, if burp.jar contains the burp suite or individual plugin, and BurpProxyExtender.jar contains the class BurpExtender, use the following command to launch burp and load the IBurpExtender implementation:

        java -classpath burp.jar;BurpProxyExtender.jar burp.StartBurp

Field Summary
`static int` | `ACTION_DO_INTERCEPT` Causes burp proxy to present the message to the user for manual review or modification.
`static int` | `ACTION_DONT_INTERCEPT` Causes burp proxy to forward the message to the remote server.
`static int` | `ACTION_DROP` Causes burp proxy to drop the message and close the client connection.
`static int` | `ACTION_FOLLOW_RULES` Causes burp proxy to follow the current interception rules to determine the appropriate action to take for the message.

Method Summary
`void` | `applicationClosing()` This method is invoked immediately before the calling application exits.
`byte[]` | `processProxyMessage(int messageReference, boolean messageIsRequest, java.lang.String remoteHost, int remotePort, boolean serviceIsHttps, java.lang.String httpMethod, java.lang.String url, java.lang.String resourceType, java.lang.String statusCode, java.lang.String responseContentType, byte[] message, int[] action)` This method is invoked by burp proxy whenever a client request or server response is received.
`void` | `registerHttpRequestMethod(java.lang.reflect.Method makeHttpRequestMethod, java.lang.Object makeHttpRequestObject)` This method is invoked on startup by burp repeater.
`void` | `setCommandLineArgs(java.lang.String[] args)` This method is invoked immediately after the implementation's constructor to pass the command-line arguments passed to the calling application on startup.

Field Detail

### ACTION_FOLLOW_RULES

    static final int ACTION_FOLLOW_RULES

  Causes burp proxy to follow the current interception rules to determine the appropriate action to take for the message.

  See Also:
    Constant Field Values

### ACTION_DO_INTERCEPT

    static final int ACTION_DO_INTERCEPT

  Causes burp proxy to present the message to the user for manual review or modification.

  See Also:
    Constant Field Values

### ACTION_DONT_INTERCEPT

    static final int ACTION_DONT_INTERCEPT

  Causes burp proxy to forward the message to the remote server.

  See Also:
    Constant Field Values

### ACTION_DROP

    static final int ACTION_DROP

  Causes burp proxy to drop the message and close the client connection.

  See Also:
    Constant Field Values

Method Detail

### setCommandLineArgs

    void setCommandLineArgs(java.lang.String[] args)

  This method is invoked immediately after the implementation's constructor to pass the command-line arguments passed to the calling application on startup. It allows implementations to control aspects of their behaviour at runtime by defining their own command-line arguments

  Parameters:
    `args` - The command-line arguments passed to the calling application on startup.

### processProxyMessage

    byte[] processProxyMessage(int messageReference,
                               boolean messageIsRequest,
                               java.lang.String remoteHost,
                               int remotePort,
                               boolean serviceIsHttps,
                               java.lang.String httpMethod,
                               java.lang.String url,
                               java.lang.String resourceType,
                               java.lang.String statusCode,
                               java.lang.String responseContentType,
                               byte[] message,
                               int[] action)

  This method is invoked by burp proxy whenever a client request or server response is received. It allows implementations to perform logging functions, modify the message, specify an action (intercept, drop, etc.) and perform any other arbitrary processing.

  Parameters:
    `messageReference` - An identifier which is unique to a single request/response pair. This can be used to correlate details of requests and responses and perform processing on the response message accordingly.
    `messageIsRequest` - Flags whether the message is a client request or a server response.
    `remoteHost` - The hostname of the remote HTTP server.
    `remotePort` - The port of the remote HTTP server.
    `serviceIsHttps` - Flags whether the protocol is HTTPS or HTTP.
    `httpMethod` - The method verb used in the client request.
    `url` - The requested URL.
    `resourceType` - The filetype of the requested resource, or a zero-length string if the resource has no filetype.
    `statusCode` - The HTTP status code returned by the server. This value is `null` for request messages.
    `responseContentType` - The content-type string returned by the server. This value is `null` for request messages.
    `message` - The full HTTP message.
    `action` - An array containing a single integer, allowing the implementation to communicate back to burp a non-default interception action for the message. The default value is `ACTION_FOLLOW_RULES`. Set `action[0]` to one of the other possible values to perform a different action.
  Returns:
    Implementations should return either (a) the same object received in the `message` paramater, or (b) a different object containing a modified message.

### registerHttpRequestMethod

    void registerHttpRequestMethod(java.lang.reflect.Method makeHttpRequestMethod,
                                   java.lang.Object makeHttpRequestObject)

  This method is invoked on startup by burp repeater. It registers a method that may be invoked by the implementation to issue arbitrary HTTP/S requests and receive responses.

  The method registered has the following signature:

           public byte[] makeHttpRequest(
               String host,
               int port,
               boolean useHttps,
               byte[] request) throws Exception;

  The makeHttpRequest method returns the full response from the server, or throws an Exception with an informative message if any kind of error occurs.

  Implementations must invoke the makeHttpRequest method dynamically, for example:

           byte[] response = (byte[]) makeHttpRequestMethod.invoke(
               makeHttpRequestObject,
               new Object[]
               {
                   "target.com",
                   new Integer(80),
                   new Boolean(false),
                   "GET / HTTP/1.0\r\n\r\n".getBytes()
               });

  The call to registerHttpRequestMethod need not return, and implementations may use the invoking thread for any purpose.

  Parameters:
    `makeHttpRequestMethod` - A method which may be dynamically invoked by implementations to issue arbitrary HTTP/S requests.
    `makeHttpRequestObject` - An object upon which the method must be invoked.

### applicationClosing

    void applicationClosing()

  This method is invoked immediately before the calling application exits. It allows implementations to carry out any clean-up actions necessary (e.g. flushing log files or closing database resources)

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD